/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.party.controller;

import cn.hutool.core.lang.Assert;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.party.entity.Meeting;
import org.springblade.party.wrapper.MeetingWrapper;
import org.springblade.system.expand.feign.IConfClient;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.party.entity.News;
import org.springblade.party.vo.NewsVO;
import org.springblade.party.wrapper.NewsWrapper;
import org.springblade.party.service.INewsService;
import org.springblade.core.boot.ctrl.BladeController;

import java.util.Map;

/**
 * 党内咨询列表表 控制器
 *
 * @author BladeX
 * @since 2021-04-19
 */
@RestController
@AllArgsConstructor
@RequestMapping("/news")
@Api(value = "党内咨询列表表", tags = "党内咨询列表表接口")
public class NewsController extends BladeController {

	private final INewsService newsService;
	private final IConfClient confClient;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入news")
	public R<NewsVO> detail(News news) {
		News detail = newsService.getOne(Condition.getQueryWrapper(news));
		return R.data(NewsWrapper.build().entityVO(detail));
	}

	/**
	 * 分页 党内咨询列表表
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入news")
	public R<IPage<NewsVO>> list(@RequestParam Map<String,Object> news, Query query) {
		Integer hitStatus = null;
		Integer newsStatus = null;
		Integer classId = null;
		Integer isSupportComment = null;
		Long branchId = null;
		if(news.get("hitStatus") != null){
			hitStatus = Integer.parseInt(String.valueOf(news.get("hitStatus")));
			news.remove("hitStatus");
		}
		if(news.get("newsStatus") != null){
			newsStatus = Integer.parseInt(String.valueOf(news.get("newsStatus")));
			news.remove("newsStatus");
		}
		if(news.get("classId") != null){
			classId = Integer.parseInt(String.valueOf(news.get("classId")));
			news.remove("classId");
		}
		if(news.get("isSupportComment") != null){
			isSupportComment = Integer.parseInt(String.valueOf(news.get("isSupportComment")));
			news.remove("isSupportComment");
		}
		if(news.get("branchId") != null){
			branchId = Long.parseLong(String.valueOf(news.get("branchId")));
			news.remove("branchId");
		}
		LambdaQueryWrapper<News> lambdaQueryWrapper = Condition.getQueryWrapper(news, News.class).lambda();
		lambdaQueryWrapper.eq(hitStatus != null, News::getHitStatus, hitStatus);
		lambdaQueryWrapper.eq(newsStatus != null, News::getNewsStatus, newsStatus);
		lambdaQueryWrapper.eq(classId != null, News::getClassId, classId);
		lambdaQueryWrapper.eq(isSupportComment != null, News::getIsSupportComment, isSupportComment);
		lambdaQueryWrapper.eq(branchId != null, News::getBranchId, branchId);
		IPage<News> pages = newsService.page(Condition.getPage(query), lambdaQueryWrapper);
		return R.data(NewsWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页 党内咨询列表表
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入news")
	public R<IPage<NewsVO>> page(NewsVO news, Query query) {
		IPage<NewsVO> pages = newsService.selectNewsPage(Condition.getPage(query), news);
		return R.data(pages);
	}

	/**
	 * 新增 党内咨询列表表
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入news")
	public R save(@Valid @RequestBody News news) {
		return R.status(newsService.save(news));
	}

	/**
	 * 修改 党内咨询列表表
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入news")
	public R update(@Valid @RequestBody News news) {
		return R.status(newsService.updateById(news));
	}

	/**
	 * 新增或修改 党内咨询列表表
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入news")
	public R submit(@Valid @RequestBody News news) {
		news.setImg(confClient.removePrefix(news.getImg()));
		return R.status(newsService.saveOrUpdate(news));
	}


	/**
	 * 删除 党内咨询列表表
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(newsService.deleteLogic(Func.toLongList(ids)));
	}


}
